CPU 286
ORG	00h		;Device Driver
section .text

header:
	dd	-1
attribute:
	dw	2000h		;16bitZN^ int25h
	dw	strategy
	dw	initial
	db	1		;ubNfoCX̏ꍇ͐
;;name:	db	"MECIATA"LN^foCX̏ꍇ͖O

packet:
	dd	0
BPB_ptr:	dw	bpb_struc
partition_start:
	dd	0		;ꉞ4byteƂ邯 ʂ3fhł 32bit(28bit)
;;fat_buffer:
;;	times	11	db	0
bpb_struc:				; ȉ2GBDOS6
sectors:	dw	200h		; ZN^oCg
		db	40h		; AP[Vjbg
yoyaku:	dw	02h		; \ZN^
fatn:		db	02h		; e`s
rootd:		dw	0C00h		; fBNg
sect16:	dw	0h		; SZN^(<0x10000)
		db	0F8h		; fBAhc
fats:		dw	0EFh		; e`sTCY
		dw	63		;BIOSZN^
		dw	16		;BIOSwbh
		dd	3F0h		;HiddenZN^
		dd	003BB800h	;SZN^(>0xFFFF)

fat32sz:	dd	03C8h
fat32exflag:	dw	0
fat32ver	dw	0
fat32cluster	dd	0
fat32info	dw	1
fat32BKBS	dw	6
fat32bpbreserv	times	12 db	0ffh
fat32drvnum	db	0
fat32reserv	db	0
fat32bootsig	db	0
fat32volid	dd	0
fat32vollab	times	11 db 0ffh
fat32type	db	"FAT32"

;;times	512	db 0

strategy:
	mov	[cs:packet],bx
	mov	[cs:packet+2],es
	retf


BUILD_BPB:
	mov	word [si+18],bpb_struc	;BPBnΌOShCuio[
	mov	word [si+20],cs	;̂Ƃ̓|C^̃|C^nƎs
	ret
MEDIACHECK:
	mov	al,1		;==no error
	mov	[si+14],al
	ret
%if 0
removable:
	mov	al,1
	mov	[si+4],al	;==REMOVABLE
	ret
;//%if 0
longwait:
	push	cx
	mov	cx,20h
out5f:	out	5fh,al
	loop	out5f
	pop	cx
	ret
%else
longwait:
	push	cx
	mov	cx,20h
longwait10:	
	push	ax
	push	bx
	push	cx
	push	dx
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	loop	longwait10
	pop	cx
	ret
%endif

waitloop_d:
	mov	al,[ds:7]
	test	al,01h
	jne	error0
	test	al,80h
	jne	waitloop_d
	test	al,08h
	je	waitloop_d
	ret

write:
;;mov	bx,[si+1ah]	;==JnZN^ԍ16bit==p[eBV擪̃ItZbg?
;;mov	dx,[si+1ch]	;JnZN^16bit
	mov	bx,[si+14h]	;==JnZN^ԍ16bit==p[eBV擪̃ItZbg
	xor	dx,dx		;JnZN^16bit == 0
	mov	cx,[si+18]	;==ZN^JEg
	add	bx,[cs:partition_start]
	adc	dx,0
	add	dx,[cs:partition_start+2]
;;	cmp	dh,40h
;;	ja	error		;28bitw肵G[f
;;	or	dh,40h

	cmp	cx,0xff
	ja	error

	xor	ax,ax
	mov	ah,[CS:Memwin0]
	mov	es,ax

	cmp	dh,3fh
	ja	write48		;28bitw肵Ȃ48bitANZX
	or	dh,40h

	cli	;;荞݋֎~Ă݂

	mov	byte [es:2],cl	;sectors
	mov	byte [es:3],bl	;LBA low
	mov	byte [es:4],bh	;LBA middle
	mov	byte [es:5],dl	;LBA high
	mov	byte [es:6],dh	;LBA mode
	mov	byte [es:7],30h	;write
	jmp	write0
write48:
	cli	;;荞݋֎~Ă݂

	mov	byte [es:2],cl	;sectors
	mov	byte [es:3],dh	;LBA 24-31
	mov	byte [es:4],ch	;LBA 32-39 ==0
	mov	byte [es:5],ch	;LBA 40-47 ==0
;;	mov	byte [es:6],dh	;

	mov	byte [es:3],bl	;LBA low
	mov	byte [es:4],bh	;LBA middle
	mov	byte [es:5],dl	;LBA high
	mov	dh,40h
	mov	byte [es:6],dh	;LBA mode
	mov	byte [es:7],34h	;write 48bit

write0:
	lds	si,[si+14]		;] DS:SI

transferloop0:
	mov	di,400h		;] es:di=DA00:0400
	push	cx
	mov	cx,200h
waitloop:
	call	longwait
	mov	al,[es:7]
	test	al,01h
	jne	error
	test	al,80h
	jne	waitloop
	test	al,40h
	je	waitloop
	call	longwait
trans1sector:
	movsb
	loop	trans1sector
	pop	cx
waitloop1:
	call	longwait
	mov	al,[es:7]
	test	al,01h
	jne	error
	test	al,80h
	jne	waitloop1
	test	al,40h
	je	waitloop1
	call	longwait
	loop	transferloop0

	sti	;荞݋
	ret
read:
;;mov	bx,[si+1ah]	;==JnZN^ԍ16bit==p[eBV擪̃ItZbg?
;;mov	dx,[si+1ch]	;JnZN^16bit
	mov	bx,[si+14h]	;==JnZN^ԍ16bit==p[eBV擪̃ItZbg
	xor	dx,dx		;JnZN^16bit == 0
	mov	cx,[si+18]	;==ZN^JEg(FFh܂łc)
	add	bx,[cs:partition_start]
	adc	dx,0
	add	dx,[cs:partition_start+2]


	cmp	cx,0xff
	ja	error


	xor	ax,ax
	mov	ah,[CS:Memwin0]
	mov	ds,ax

	cmp	dh,3fh
	ja	read48
	or	dh,40h

	mov	byte [ds:2],cl	;sectors
	mov	byte [ds:3],bl	;LBA low
	mov	byte [ds:4],bh	;LBA middle
	mov	byte [ds:5],dl	;LBA high
	mov	byte [ds:6],dh	;LBA mode
	mov	byte [ds:7],20h	;read
	jmp	read0
read48:

	mov	byte [ds:2],cl	;sectors
	mov	byte [ds:3],dh	;LBA 24-31
	mov	byte [ds:4],ch	;LBA 32-39 ==0
	mov	byte [ds:5],ch	;LBA 40-47 ==0
;;	mov	byte [es:6],dh	;
	mov	byte [ds:3],bl	;LBA low
	mov	byte [ds:4],bh	;LBA middle
	mov	byte [ds:5],dl	;LBA high
	mov	dh,40h
	mov	byte [ds:6],dh	;LBA mode
	mov	byte [ds:7],24h	;read 48bit

read0:
	call	waitloop_d
	push	ds
	lds	si,[cs:packet]
	les	di,[si+14]		;] es:di
	pop	ds
transferloop1:
	mov	si,400h		;] ds:si=DA00:0400
	push	cx
	mov	cx,200h
	call	waitloop_d
rep	movsb
	pop	cx
	loop	transferloop1
	ret
error0:
	pop	ax
error:
	mov	word[si + 3], 8108h
	ret
main:
	cli
	sub	sp,50h	;悭킩񂯂ǃfobKŎ~߂Ƃ͂

	mov	dx,1e8eh
	in	al,dx
	mov	[CS:bankwin],al
	mov	al,[CS:PCMCIAwin]
	out	dx,al		;PCMCIAɕύX

	push	ds
	push	es
	pusha
	cld
	push	returnpoint
	lds	si,[cs:packet]
	mov	byte [si + 4],1	;=done
	mov	al,[si+2]	;ꂪR}h?

	cmp	al,1		;==MEDIA CHECK
	je	MEDIACHECK
	cmp	al,2
	je	BUILD_BPB
	cmp	al,4		;==INPUT read
	je	read
	cmp	al,8		;==OUTPUT write
	je	write
	cmp	al,9		;==OUTPUT&Verify  write no verify
	je	write
;;	cmp	al,15		;REMOVABLE
;;	je	removable
	mov	word[si + 3], 8103h
	pop	ax

returnpoint:
	popa
	pop	es
	pop	ds
	mov	dx,1e8eh
	mov	al,[CS:bankwin]
	out	dx,al		;̑ɕύX
	sti
	add	sp,50h	;悭킩񂯂
	retf
bankwin:
	db	81h	;ɕۊǂĂ̂Kv
PCMCIAwin:
	db	84h	;قƂǂ84h
Memwin0:
	db	0DAh	;;MECIA3͂Œ 
IO0:
	dw	3D0h	;;肱̂ق悢?
outee:
;;	out	5fh,al
;;	call	longwait
	mov	dx,3e0h
	out	dx,al
	xchg	al,ah
	inc	dx
;;	out	5fh,al
;;	call	longwait
	out	dx,al
	ret
joutyu_end:

initial:
	cld
	lds	bx,[cs:packet]

	push	di
	push	es
	mov	cx,[bx+20]
	mov	es,cx
	mov	di,[bx+18]
	mov	al,0x2f	;'/'

;;	mov	al,0x0a		;LF
	mov	cx,0ffh		;255 K
	repnz	scasb
	cmp	cx,0
	je	nooption

	mov	ax,[es:di]
	cmp	ax,'M='
	jne	nooption
	inc	di
	inc	di
	mov	ax,[es:di]
;ascii to hex
	and	ax,0dfdfh		;啶

	cmp	al,40h
	ja	moji
	cmp	al,19h
	ja	nooption
	cmp	al,10h
	jb	nooption
	and	al,0fh
	jmp	nimojime
moji:
	cmp	al,46h
	ja	nooption
	and	al,0fh
	add	al,09h

nimojime:
	cmp	ah,40h
	ja	moji2
	cmp	ah,19h
	ja	nooption
	cmp	ah,10h
	jb	nooption
	and	ah,0fh
	jmp	hex
moji2:
	cmp	ah,46h
	ja	nooption
	and	ah,0fh
	add	ah,09h
hex:
	shl	al,04h
	or	ah,al
	xor	al,al
	cmp	ah,0c0h		;ɂȂ肤Ƒz肷镔ȊO
	jb	nooption
	cmp	ah,0efh		;ɂȂ肤Ƒz肷镔ȊO
	ja	nooption
;;	mov	[cs:Memwin0],ah
;;	dec	ah
;;	shr	ax,4
;;	mov	[cs:CardbusControl+1],ax
nooption:
	pop	di
	pop	es

	call	START
	jc	sippai0

	lds	bx,[cs:packet]
	mov	byte [bx+4],1	;done
	mov	byte [bx+13],1	;unit numbers
	mov	word [bx+14],joutyu_end	;풓镔̏I蕔w
	mov	word [bx+16],cs
	mov	word [bx+18],BPB_ptr	;BPBnΌOShCuio[
	mov	word [bx+20],cs		;łinitial̎̓|C^̃|C^ȂႾ???
;ȂĂbx+18ɂdevice=̌̕i[Ă|C^XĂ

	mov	al,[bx+22]		;Drive number

	push	ds
	push	cs
	pop	ds
	mov	dx,seikou
	mov	ah,9
	int	21h

	mov	word [cs:attribute+4],main
	pop	ds

	retf

sippai0:
	lds	bx,[cs:packet]
	mov	byte [bx+4],1	;done
	mov	byte [bx+13],0	;unit numbers
	mov	word [bx+14],0	;풓镔̏I蕔w
	mov	word [bx+16],cs
	mov	word [bx+18],bpb_struc
	mov	word [bx+20],cs

	push	ds
	push	cs
	pop	ds
	mov	dx,sippai
	mov	ah,9
	int	21h

	mov	word [cs:attribute+4],main

	pop	ds
	retf

START:
	jmp	MAIN
nothing0:
	pop	ax
nothing:
	stc
	ret

MAIN:
	mov	dx,0a8eh
	in	al,dx
	cmp	al,0ffh
	je	nothing

	mov	dx,1a8eh
	in	al,dx
	test	al,08h
	jne	cardinsert
	jmp	nothing

cardinsert:
	or	al,2h
	out	dx,al		;PowerON
	out	5fh,al
	mov	dx,3a8eh
	mov	al,0ffh
	out	dx,al		;IRQ disable
	out	5fh,al
	mov	dx,2a8eh
	in	al,dx
	or	al,0xa0	;8bitIO card
	and	al,~0x50	;{AhXϊ[h
	out	dx,al
	out	5fh,al
	call	debugprint
%if 0
	mov	ax,[cs:IO0]
	mov	dx,4a8eh	;{̑ݒ
	out	dx,ax		;16bitŐݒ
	out	5fh,al
	mov	dx,5a8eh	;J[hݒ
	out	dx,ax		;16bitŐݒ
	out	5fh,al
%endif
	mov	dx,7a8eh
	in	al,dx
	or	al,0x20
	out	dx,al		;[h
	out	5fh,al


	mov	dx,7a8eh
	in	al,dx
	and	al,~0x20
	out	dx,al		;Common[h
	out	5fh,al

;@`FbN PC-98HÂ݂̒l
	push	es
	xor	ax,ax
	mov	es,ax
	cmp 	word[es:410h],0	;PC-98HAp̈
	je	notHA98
	cmp 	word[es:412h],0	;PC-98HAp̈
	je	notHA98

	mov	al,82h
	mov	[CS:PCMCIAwin],al
	mov	al,0DCh
	mov	[CS:bankwin],al

notHA98:
	pop	es
;MMIOATA߂Γǂݏ\ɂȂ
	push	es
	push	ds
;;	cli	łɋ֎~Ă
	mov	dx,1e8eh
	in	al,dx
	mov	[CS:bankwin],al
	mov	al,[CS:PCMCIAwin]
	out	dx,al		;PCMCIAɕύX
	xor	ax,ax
	mov	ah,[CS:Memwin0]
	mov	ds,ax
	
waitloop_d00:
	mov	byte [ds:2],1	;1sector
	mov	byte [ds:3],0	;LBA low
	mov	byte [ds:4],0	;LBA middle
	mov	byte [ds:5],0	;LBA high
	mov	byte [ds:6],40h	;LBA mode
	mov	byte [ds:7],20h	;read 1sector MBR

call	debugprint
waitloop_d0:
	mov	al,[ds:7]
	test	al,01h
	jne	nothing
	test	al,80h
	jne	waitloop_d0
	test	al,08h
	je	waitloop_d00
call	debugprint

	push	cs
	pop	es
	mov	di,DATA
	mov	si,400h
	mov	cx,200h
rep	movsb

	mov	di,DATA+1beh
	add	di,8
	mov	ax,[es:di]
	mov	[cs:partition_start],ax
	mov	dx,[es:di+2]
	mov	[cs:partition_start+2],dx
	and	dh,3fh		;;ɑ1p[eBV擪28bit܂ł pɑ1p[eBV̕ɍƂKv Ȃł
	or	dh,40h		;;//LBAw

waitloop_d01:
	mov	byte [ds:2],1	;1sector
	mov	byte [ds:3],al	;LBA low
	mov	byte [ds:4],ah	;LBA middle
	mov	byte [ds:5],dl	;LBA high
	mov	byte [ds:6],dh	;LBA mode
	mov	byte [ds:7],20h	;read 1sector PBR
call	debugprint
waitloop_d1:
	mov	al,[ds:7]
	test	al,01h
	jne	nothing
	test	al,80h
	jne	waitloop_d1
	test	al,08h
	je	waitloop_d01
call	debugprint
	mov	di,DATA
	mov	si,400h
	mov	cx,200h
rep	movsb

	push	cs
	pop	es
	push	cs
	pop	ds
	mov	si,DATA+11
	mov	di,bpb_struc
;;	mov 	cx,25		;25byte
	mov	cx,strategy
	sub	cx,bpb_struc
rep	movsb

	mov	dx,1e8eh
	mov	al,[CS:bankwin]
	out	dx,al		;̑ɕύX

	call	fatcheck
	jc	nofattable

;;	mov	si,DATA
;;	mov	di,fat_buffer
;;	mov	cx,36/2	;36byte
;;	mov	cx,100h	;512byte
;;rep	movsw
	clc
	pop	ds
	pop	es
	ret
nofattable:
	sti
	stc
	pop	ds
	pop	es
	ret

fatcheck:
	mov	ax,[cs:bpb_struc+54-11]
	cmp	ax,'FA'
	je	fatOK
	mov	ax,[cs:fat32type]
	cmp	ax,'FA'
	je	fatOK
	stc
	ret
fatOK:
	clc
	ret

CPU 286
CPUcheck:
;286ȏォ̃`FbN
	mov	ax,0f000h
	push	ax
	popf
	pushf		;286Ƃbit
	pop	ax	;߂ĂꂪĂ286
	and	ax,0f000h
	je	over386
	stc
	ret
over386:
	clc
	ret

debugprint:
ret
	push	ds
	push	cs
	pop	ds
	mov	dx,dprint
	mov	ah,09h
	int	21h
	pop	ds
	ret

seikou:
db	"hCogݍ",0xd,0xa,"$"
sippai:
db	"hCogݍݎs",0xd,0xa,"$"
dprint:
db	"hCogݍݒ",0xd,0xa,"$"
DATA:
	times	512 db 00h
